isValidConnection = function(action, provider, receiver, providerSettings, receiverSettings) {
    if (action === null) {
        return "Invalid action";
    }
    if (provider === null) {
        return "Invalid provider";
    }
    if (receiver === null) {
        return "Invalid receiver";
    }
    let validProvider = action.isValidProvider(provider);
    if (!validProvider) {
        return "Action does not support provider";
    }
    let validReceiver = action.isValidReceiver(receiver);
    if (!validReceiver) {
        return "Action does not support receiver";
    }
    let validProviderSettings = provider.isValidProviderSettings(action, providerSettings);
    if (!validProviderSettings) {
        return "Provider Settings does not contain the required settings";
    }
    let validReceiverSettings = receiver.isValidReceiverSettings(action, receiverSettings);
    if (!validReceiverSettings) {
        return "Receiver Settings does not contain the required settings";
    }
    return true;
}

module.exports = isValidConnection;