const sendLinkActionHandler = {
    // all actions must implement this function
    apply: function(payload, provider, receiver, providerSettings, receiverSettings){
        return {data, options} = receiver.sendLink(receiverSettings, provider.getURL(providerSettings, payload));
    },

    // all actions must implement this function
    isValidProvider: function(provider){
        return (typeof provider.isValidProviderSettings === 'function' &&
        typeof provider.getURL === 'function');
    },

    // all actions must implement this function
    isValidReceiver: function(receiver){
        return (typeof receiver.isValidReceiverSettings === 'function' &&
        typeof receiver.sendLink === 'function');
    }
}

module.exports = sendLinkActionHandler;