let http = require('http');
let request = require('request')

const databaseWrapper = {
    addConnection: function(usr, action, prov, provSet, rec, recSet){
        let postData = { command: 'add', usr, action, prov, provSet, rec, recSet };
        return sendDatabaseRequest(postData);
    },

    editConnection: function(uuid, action, prov, provSet, rec, recSet){
        let postData = { command: 'update', uuid, action, prov, provSet, rec, recSet };
        return sendDatabaseRequest(postData);
    },

    removeConnection: function(uuid){
        let postData = { command: 'remove', uuid };
        return sendDatabaseRequest(postData);
    },

    updateConnections: function(user){
        let postData = { command: 'get_user'};
        return sendDatabaseRequest(postData);
    },

    getConnection: function(uuid){
        let postData = { command: 'get_uuid', uuid };
        return sendDatabaseRequest(postData);
    }
}

let sendDatabaseRequest = function(postData) {
    let databaseServerOptions = {
        hostname: 'database',
        url: 'http://database:8000',
        port: '8000',
        path: '/',
        method: 'POST',
        headers: {
            'Content-Type': 'application/json',
            'Content-Length': JSON.stringify(postData).length
        }
    };
    const req = http.request(databaseServerOptions, function (error, response, body) {
        //console.log(error,response.body);
        console.log("In error")
        console.log(response)
        console.log(body)
        console.log(error)
        return body;
    });
    console.log("Done with send database")
    req.write(JSON.stringify(postData))
    req.end();
    /*request(databaseServerOptions, (error, response, body) => {
        //console.log(error);
        console.log(response);
        console.log(body);
    });*/
}

module.exports = databaseWrapper;